;--------------------------------------
;    Super-Hires-Interlace displayer
;       (C)1994 by Colabor/Vermes
;    Reprogrammed by Dundera 1998
;--------------------------------------
;tohleto je zdrojak konvertoru z RAW formatu
;obrazku do SHI formatu na C64.
; Vstupni obrazek musi mit max. sirku 256 bodu,
; a musi byt v 8 barvach.



; rozlozeni obrazku v pameti
; $4000 - $5f40  bitmap1
; $6000 - $7400  sprites1
; $7400 - $7800  hires colors
; $7800 - $7c00  copy of $7400 - $7800
; $c000 - $df40  bitmap2
; $e000 - $f400  sprites2
; $f400 - $f800  copy of $7400 - $7800
; $f800 - $fc00  copy of $7400 - $7800

;format of SHI file
;$7fff          packing byte
;$8000 - $895f  bitmap 1
;$8960 - $92bf  bitmap 2
;$92c0 - $a6bf  sprites 1
;$a6c0 - $babf  sprites 2
;$bac0 - $bbeb  hires colors
;$bbec - $bbf3  sprites colors
;other bytes are unimportant.



sirka_max  = $0900
vyska_max  = $0901
palet_size = $0902


*=$1000
;
; **** externe spruenge **** 
;
eab1e   =$ab1e
;eea31   =$ea31
;eea81   =$ea81

cint    =$ff81
ioinit  =$ff84

open    = $ffc0
chkin   = $ffc6
chrin   = $ffcf
chkout  = $ffc9
chrout  = $ffd2


setlfs  =$ffba
setnam  =$ffbd
load    =$ffd5
save    =$ffd8
close   =$ffc3
clall   =$ffe7
;
; **** felder **** 
;
f7400   =$7400   ;hires colors
f7500   =$7500
f7600   =$7600
f7700   =$7700
f7800   =$7800
f7900   =$7900
f7a00   =$7a00
f7b00   =$7b00 

ff400   =$f400   ;hires colors
ff500   =$f500
ff600   =$f600
ff700   =$f700
ff800   =$f800
ff900   =$f900
ffa00   =$fa00
ffb00   =$fb00
;
; **** absolute adressen **** 
;
a01     =$01
a02     =$02
a03     =$03
a04     =$04
a05     =$05
a06     =$06
a07     =$07
a08     =$08
a09     =$09

ac1     =$c1   ;ukazatel pro save
ac2     =$c2

ac6     =$c6   ;ukazatel bufferu klavesnice


a0408   =$0408
a0409   =$0409
a040a   =$040a
a040b   =$040b

a0426   =$0426
a0427   =$0427
a0433   =$0433
a0434   =$0434
a045b   =$045b
a045c   =$045c


a77f8   =$77f8  ;ukazatele pro sprajty
a77f9   =$77f9
a77fa   =$77fa
a77fb   =$77fb
a77fc   =$77fc
a77fd   =$77fd
a77fe   =$77fe
a77ff   =$77ff

a7bf8   =$7bf8  ;ukazatele pro sprajty
a7bf9   =$7bf9
a7bfa   =$7bfa
a7bfb   =$7bfb
a7bfc   =$7bfc
a7bfd   =$7bfd
a7bfe   =$7bfe
a7bff   =$7bff

a7fff   =$7fff  ;packing byte

af7f8   =$f7f8  ;ukazatele pro sprajty
af7f9   =$f7f9
af7fa   =$f7fa
af7fb   =$f7fb
af7fc   =$f7fc
af7fd   =$f7fd
af7fe   =$f7fe
af7ff   =$f7ff


afbf8   =$fbf8  ;ukazatele pro sprajty
afbf9   =$fbf9
afbfa   =$fbfa
afbfb   =$fbfb
afbfc   =$fbfc
afbfd   =$fbfd
afbfe   =$fbfe
afbff   =$fbff

;
; **** pointer **** 
;
p02     =$02
p04     =$04
p06     =$06
p08     =$08
;
; **** programm **** 
;
;            



       jmp start
       jmp zobrazeni
       
start  = *       
       sei
       lda #$34
       sta $01   
       
       lda #$00
       sta a02
       lda #$40
       sta a03           ;$4000
       ldx #$bc         ;- $fc00
       ldy #$00
       lda #$00
i1013  sta (p02),y       ;vyfilluje pamet
       iny
       bne i1013
       inc a03
       dex
       bne i1013 
       
       lda #$37
       sta $01
       lda #$ea
       sta $0315
       lda #$31
       sta $0314         ;standardni irq
       
       jsr cint          ;cint - nastavi editor & vic
       jsr ioinit        ;ioinit - nastavi  cia
       cli
       lda #$00
       sta $d020
       sta $d021
       
       lda #<info_txt
       ldy #>info_txt
       jsr $ab1e         ;print hlavicky
       

;       lda #<e1846
;       ldy #>e1846
;       jsr $ab1e         ;print "colors"
;       
;       jsr i16ee         ;get text
;       
;       lda a0408         ;vezme informaci z obrazovky
;       jsr char2hex      ;zkonvertuje na cislo barvy


        lda #$0f
        sta hires_col1         ;a ulozi  (F)    (hires color high nibble)
;       
;       lda a0409
;       jsr char2hex

        lda #$0c
        sta hires_col0         ;(C) -           (hires color low nibble)
;       
;       lda a040a
;       jsr char2hex

        lda #$0b
        sta spt_color0         ;(B)             (sprite color)
;       
;       lda a040b
;       jsr char2hex

        lda #$00
        sta spt_color1         ;(0)             (sprite color)



       
       lda #<e1872
       ldy #>e1872
       jsr eab1e         ;print offset y
       
       jsr i16ee         ;get text
       lda buffer
       jsr char2hex      ;convert char to hex
       asl a
       asl a
       asl a
       asl a
       sta off_y         ;high nibble
       
       lda buffer+1
       jsr char2hex      ;convert low nibble
       clc
       adc off_y
       sta off_y         ;off_y - offset y info


       
       lda #<e1883
       ldy #>e1883
       jsr $ab1e         ;print offset x
       
       jsr i16ee         ;get
       lda buffer
       jsr char2hex
       asl a
       asl a
       asl a
       asl a
       sta off_x         ;high nibble
       lda buffer+1
       jsr char2hex
       clc
       adc off_x
       sta off_x         ;off_x - offset x info
       



       lda #<load_txt
       ldy #>load_txt
       jsr $ab1e         ;print load name:
       
       jsr i16ee         ;get name to buffer
       
       lda #$01
       ldx $ba
       ldy #$00          ;new load start addres
       jsr setlfs         ;setlfs
       
       lda name_len          ;
       ldx #<buffer
       ldy #>buffer
       jsr setnam         ;setnam
       
       jsr open 
       

       ldx #$01
       jsr chkin
       bcc fileopen_ok
       
error  lda #$01
       jsr close
       jsr clall
       
       lda #<file_err
       ldy #>file_err
       jmp $ab1e
;------------------------       

       
fileopen_ok lda #<e1858
            ldy #>e1858
            jsr $ab1e         ;print creating ...

       
          ldy #$00
read_head jsr chrin
          cmp head_tab,y
          bne bad_head
          iny
          cpy #$06
          bne read_head
          
          jsr chrin  ;$00
          jsr chrin  ;$04  ;pocet bitu na pixel
          cmp #$04
          
          jsr chrin
          jsr chrin
          sta sirka_max
          
          jsr chrin
          jsr chrin
          sta vyska_max
          
          jsr chrin  ;velikost palety (2bytes)
          jsr chrin
          sta palet_size
          
          ldy #18    ;18 bajtu preskocit
get_out   jsr chrin
          dey
          bne get_out
          
          ldy palet_size
get_palet jsr chrin      ;R
          jsr chrin      ;G
          jsr chrin      ;B
          dey
          bne get_palet
          
          lda off_y      ;zadny radkovy posuv
          beq prev
          

getout_line ldy #$00
getout_by jsr chrin
          ldx $90
          bne bad_head

          iny
          cpy sirka_max    ;cte cely radek
          bne getout_by
          
          dec off_y
          bne getout_line  ;cte tolik radku, kolik je offset
          
          jmp prev
          




bad_head  jsr close
          jsr clall
          inc $d020
          jmp bad_head
                 
                                               
;--------------------------------------
; zacatek prevodu
;--------------------------------------
prev  ; lda #$3b
      ; sta $d011
      ; 
      ; lda $dd00
      ; and #%11111100
      ; ora #2
      ; sta $dd00
      ; 
      ; lda #$c0
      ; sta $d018       ;nahodi bitmapu
;--------------------------------       
       
       sei              
       lda #$34          ;only RAM
       sta $01
       
       
i1109  lda #$00
       sta a02           ;cislo radku nuluje
                         ;-------------|
i110d  lda #199          ;#167
       sec
       sbc a02           ;odecita cislo radku
       lsr a
       lsr a
       lsr a
       lsr a
       tay
       lda f1750,y       ;ascii
       sta a0426         ;info timer
       lda #199          ;#167
       sec
       sbc a02           ;odecte cislo radku
       and #$0f
       tay
       lda f1750,y       ;ascii
       sta a0427         ;info timer
       
       jsr convert_line  ;hlavni dekodovaci rutina
       
       inc a02           ;cislo dalsiho radku
       lda a02
       cmp #200          ;#168 test pocet radku (linek)
       bne i110d         ;-------------| (je konec?)
       


;-------------------------------------- tady se z dat pripravenych
; k zobrazeni vytvari file pro SAVE dat. (opacna konverze nez pri view)
       ldx #$00          ;set color
       lda hires_col1         ;color1
       asl a
       asl a
       asl a
       asl a
       ora hires_col0         ;color2
i1142  sta f7800,x       ;uklada Hires COLOR
       sta f7900,x
       sta f7a00,x
       sta f7b00,x
       sta f7400,x
       sta f7500,x
       sta f7600,x
       sta f7700,x
       sta ff800,x
       sta ff900,x
       sta ffa00,x
       sta ffb00,x
       sta ff400,x
       sta ff500,x
       sta ff600,x
       sta ff700,x
       inx
       bne i1142
       
       lda #$00          ;kopiruje bitmapu 1
       sta a02
       sta a04
       lda #$40
       sta a03
       lda #$80
       sta a05
       ldx #25
i1185  ldy #$5f
i1187  lda (p02),y       ;$4000
       sta (p04),y       ;$8000
       dey
       bpl i1187
       inc a03
       lda a02
       clc
       adc #$40
       sta a02
       bcc i119b
       inc a03
i119b  lda a04
       clc
       adc #$60
       sta a04
       bcc i11a6
       inc a05
i11a6  dex
       bne i1185
       
       lda #$00          ;kopiruje bitmapu 2
       sta a02
       lda #$60
       sta a04
       lda #$c0
       sta a03
       lda #$89
       sta a05
       ldx #25
i11bb  ldy #$5f
i11bd  lda (p02),y       ;$c000
       sta (p04),y       ;$8960
       dey
       bpl i11bd
       inc a03
       lda a02
       clc
       adc #$40
       sta a02
       bcc i11d1
       inc a03
i11d1  lda a04
       clc
       adc #$60
       sta a04
       bcc i11dc
       inc a05
i11dc  dex
       bne i11bb
       
       lda #$00          ;sprite 1, 2
       sta a02
       sta a04
       lda #$c0
       sta a06
       sta a08
       lda #$60
       sta a03
       lda #$e0
       sta a05
       lda #$92
       sta a07
       lda #$a6
       sta a09
       ldx #20
       ldy #$00
i11ff  lda (p02),y       ;$6000
       sta (p06),y       ;$92c0
       lda (p04),y       ;$e000
       sta (p08),y       ;$a6c0
       iny
       bne i11ff
       inc a03
       inc a07
       inc a05
       inc a09
       dex
       bne i11ff
       
       lda #$00          ;hires color
       sta a02
       lda #$c0
       sta a04
       lda #$74
       sta a03
       lda #$ba
       sta a05
       ldx #$1b
i122f  ldy #$0b
i1231  lda (p02),y       ;$7400   #$a8
       sta (p04),y       ;$bac0
       dey
       bpl i1231
       lda a02
       clc
       adc #$28
       sta a02
       bcc i1243
       inc a03
i1243  lda a04
       clc
       adc #$0c
       sta a04
       bcc i124e
       inc a05
i124e  dex
       bne i122f   
       
       lda spt_color0        ;#$02
       sta $bbec        ;sprites color
       sta $bbed
       sta $bbee
       sta $bbef
       
       lda spt_color1        ;#$00
       sta $bbf0        ;sprites color
       sta $bbf1
       sta $bbf2
       sta $bbf3     
       
       
       lda #$00         ;uncompressed atribut
       sta a7fff
       
       lda #$37
       sta a01
       cli
       lda #$01
       jsr close
       jsr clall
       

       jsr zobrazeni    ;zobrazi zkonvertovany obrazek, ceka na klavesu
       
       lda key
       cmp #$7f
       bne save_file
       rts
       



;--------------------------------------       
save_file lda #<e1894
       ldy #>e1894
       jsr eab1e         ;print save
       
       jsr i16ee         ;get
       
       lda #$01
       ldx $ba
       ldy #$01
       jsr setlfs
       
       lda name_len
       ldx #<buffer
       ldy #>buffer      
       jsr setnam
       
       jsr open
       
       ldx #$01
       jsr chkout
       bcc write_ok
       
       jmp error

write_ok lda #$ff
       sta ac1
       jsr chrout
       lda #$7f
       sta ac2
       jsr chrout
       
store_next = *
       lda #$36
       sta $01      ;vypne basic
       ldy #$00
       lda (ac1),y  ;nacte
       ldx #$37
       stx $01      ;zapne basic
       jsr chrout   ;ulozi na disk
       
       inc ac1
       bne incadr
       inc ac2
       
incadr lda ac1
       cmp #$f8
       bne store_next
       lda ac2
       cmp #$bb
       bne store_next
       
       lda #$01
       jsr close
       jsr clall
       rts
       

       
       

;--------------------------------------
; zobrazeni
;--------------------------------------
zobrazeni = *       
       lda spt_color0  ;barvy spt 0-3
       sta $d027
       sta $d028
       sta $d029
       sta $d02a 
       
       lda spt_color1  ;barvy spt 4-7
       sta $d02b
       sta $d02c
       sta $d02d
       sta $d02e
       
;       lda #$02
;       sta $d020  ;pozadi
       
       lda #$ff
       sta $d015  ;zapnout sprajty
       
       lda #$18
       sta $d000  ;pozice pro spt0,4
       sta $d008
       clc
       adc #$18
       sta $d002  ;pro 1,5
       sta $d00a
       adc #$18
       sta $d004  ;pro 2,6
       sta $d00c
       adc #$18
       sta $d006  ;pro 3,7
       sta $d00e
       
       sei
       lda #$7f
       sta $dc0d
       
       lda #$00
       sta $d010  ;9ty bit souradnic
       sta $d017  ;Y zvetseni
       sta $d01d  ;X zvetseni

       lda #$01
       sta $d01a
        
       lda #$3b
       sta $d011  ;nastavovaci register VICu
       
       lda #$1e
       sta $d012  ;rastr pro IRQ
       
       lda #<irq
       sta $0314
       lda #>irq
       sta $0315
       
       lda #$02
       sta $dd00
       
       lda #$c0
       sta $d018
       cli
       
getkey lda $dc01    ;wait until key pressed
       cmp #$ff
       beq getkey
       
       sta key
       
       sei
       lda #$31
       sta $0314
       lda #$ea
       sta $0315
       jsr ioinit       ;init cia
       jsr cint         ;init vicu
       cli
       jsr clall
       lda #$00
       sta $d020
       sta $d021
       rts
       

;--------------------------------------
;irq pri zobrazovani
;--------------------------------------       

irq             lda     #$32 ; '2'
                jsr     set_y_spt
                
                lda     #$d0    ;$f400/$7400 hires barvy
                sta     $d018
                
                ldx     #$e0 ;wait
i100f           dex     
                bne     i100f
                
                ldx     #$80
                jsr     place1
                
                ldx     #$88
                jsr     place2
                
                lda     #$47
                jsr     set_y_spt
                ldy     #1
                ldx     #$7d ; '}'
                jsr     wait
                
                lda     #$e0    ;$f800/$7800  
                sta     $d018
                ldx     #$90
                jsr     place1
                lda     #$5c
                jsr     set_y_spt
                ldy     #1
                ldx     #$7d
                jsr     wait
                
                lda     #$d0    ;$f400/$7400
                sta     $d018
                ldx     #$98
                jsr     place2
                lda     #$71
                jsr     set_y_spt
                ldy     #1
                ldx     #$8c
                jsr     wait
                
                lda     #$e0    ;$f800/$7800
                sta     $d018
                ldx     #$a0
                jsr     place1
                lda     #$86
                jsr     set_y_spt
                ldy     #1
                ldx     #$78
                jsr     wait

                lda     #$d0    ; $f400/$7400
                sta     $d018
                ldx     #$a8
                jsr     place2
                lda     #$9b
                jsr     set_y_spt
                ldy     #1
                ldx     #$85
                jsr     wait
                
                nop     
                lda     #$e0    ; $f800/$7800
                sta     $d018
                ldx     #$b0
                jsr     place1
                lda     #$b0
                jsr     set_y_spt
                ldy     #1
                ldx     #$82
                jsr     wait
                
                lda     #$d0    ; $f400/$7400
                sta     $d018
                ldx     #$b8
                jsr     place2
                lda     #$c5
                jsr     set_y_spt
                ldy     #1
                ldx     #$7d
                jsr     wait
                
                lda     #$e0    ;$f800/$7800
                sta     $d018
                ldx     #$c0
                jsr     place1
                lda     #$da
                jsr     set_y_spt
                ldy     #1
                ldx     #$87
                jsr     wait
                
                lda     #$d0    ;$f400/$7400
                sta     $d018
                ldx     #$c8
                jsr     place2
                lda     #$ef
                jsr     set_y_spt
                ldy     #1
                ldx     #$7d
                jsr     wait
                
                lda     #$e0    ; $f800/$7800
                sta     $d018
                inc     $d019
                ldy     #1
                ldx     #$5f
                jsr     wait
                
                lda     $dd00   
                eor     #2
                sta     $dd00
                
                inc     $d019
                jmp     $ea7e

;

;               s u b r o u t i n e

wait            dex     
                bne     wait
                dey     
                bne     wait
                rts     


;

;               s u b r o u t i n e

place1          stx     $77f8
                stx     $f7f8
                inx     
                stx     $77f9
                stx     $f7f9
                inx     
                stx     $77fa
                stx     $f7fa
                inx     
                stx     $77fb
                stx     $f7fb
                inx     
                stx     $77fc
                stx     $f7fc
                inx     
                stx     $77fd
                stx     $f7fd
                inx     
                stx     $77fe
                stx     $f7fe
                inx     
                stx     $77ff
                stx     $f7ff
                rts     
; end of function place1


;

;               s u b r o u t i n e

place2          stx     $7bf8
                stx     $fbf8
                inx     
                stx     $7bf9
                stx     $fbf9
                inx     
                stx     $7bfa
                stx     $fbfa
                inx     
                stx     $7bfb
                stx     $fbfb
                inx     
                stx     $7bfc
                stx     $fbfc
                inx     
                stx     $7bfd
                stx     $fbfd
                inx     
                stx     $7bfe
                stx     $fbfe
                inx     
                stx     $7bff
                stx     $fbff
                rts     
; end of function place2


;

;               s u b r o u t i n e

set_y_spt       sta     $d001
                sta     $d003
                sta     $d005
                sta     $d007
                sta     $d009
                sta     $d00b
                sta     $d00d
                sta     $d00f
                rts     






;--------------------------------------
; hlavni dekodovaci subrutina
;--------------------------------------
convert_line
           lda #$37   ;povolit ROMky
           sta $01
           
           ldy #$00
read_line  jsr chrin         ;cte ze souboru hodnoty pro jednotlive
           ldx $90
           beq notend
           lda #$00
notend     sta buffer,y   ;pixely do LINE_BUFF
           iny
           cpy sirka_max
           bne read_line
           
           lda #$00
fill_buff  sta buffer,y   ;zbytek se vynuluje (cerna barva)
           iny
           bne fill_buff
           
           lda #$34    ;po nacteni zase vypnout
           sta $01
       
       
           lda #$00
           sta a03           ;nuluje cislo sloupce
i1376      jsr i1382         ;prenasi z bitplanu do grafiky a sprajtu
           inc a03
           lda a03           ;cislo sloupce
           cmp #$60          ;#96    na celou sirku obrazku
           bne i1376
           rts


;--------------------------------------
; z bitplanu do grafiky a spritu
;--------------------------------------
i1382  lda a03          ;cislo sloupce pixelu
       clc
       adc off_x        ;pripocte se offset x
       tay
       
       lda buffer,y  ;nacte se barva pro dany pixel
       
       asl
       asl
       asl
       sta a06
       
       lda a02          ;cislo aktualniho radku
       and #$01         ;zachovat pouze spodni bit
       asl a
       asl a            ;x4
       clc
       adc a06
       sta a06          ;pricist
       
       lda a03          ;cislo sloupce
       and #$01         ;zachovat pouze spodni bit
       asl a            ;x2
       clc
       adc a06
       sta a06          ;a pricist
       
       ldy a06          ;
       lda f1710,y      ;nejaka specialni 64bajtova tabulka
       jsr i1629        ;umisteni bodu do grafiky nebo sprajtu
       
       ldy a06
       iny
       lda f1710,y      ;nejaka specialni 64bajtova tabulka
       jsr i1629        ;umisti bod do grafiky nebo sprajtu
       rts
       
f13ed  .byte %10000000  ;$80
       .byte %01000000  ;$40
       .byte %00100000  ;$20
       .byte %00010000  ;$10
       .byte %00001000  ;$08
       .byte %00000100  ;$04
       .byte %00000010  ;$02
       .byte %00000001  ;$01
       

       

       

       


;--------------------------------------       
; umistuje bod do grafiky a spritu
;--------------------------------------
i1629  beq i1642          ;cerna, nic se neuklada
       cmp #$01
       beq i1643          ;barva 1, bitmap 0
       cmp #$02
       beq i1648          ;barva 2, bitmap 1
       cmp #$03
       beq i164d          ;barva 3, sprites A0-3
       cmp #$04
       beq i1657          ;barva 4, sprites A4-7 
       cmp #$05
       beq i1652          ;barva 5, sprites B0-3
       jmp i165c          ;barva 6, sprites B4-7
i1642  rts                ;nic se nenastavuje

i1643  lda #$40           ;grafika od $4000
       jmp i16bb
       
i1648  lda #$c0           ;grafika od $c000
       jmp i16bb
       
i164d  lda #$60           ;sprajty od $6000  (A0-3)
       jmp i1661
       
i1652  lda #$e0           ;sprajty od $e000  (B0-3)
       jmp i1661
       
i1657  lda #$61           ;sprajty od $6100  (A4-7)
       jmp i1661
       
i165c  lda #$e1           ;sprajty od $e100  (B4-7)
       jmp i1661
       
;----------- uklada do sprajtu
i1661  sta a05      ;kam to prijde

       ldx #$ff
       lda a02      ;cislo radku
i1667  inx
       sec
       sbc #$15     ;odecte 21
       bcs i1667
       adc #$15     ;pricte 21
       sta a170f
       txa
       asl a
       clc
       adc a05
       sta a05
       lda a170f
       asl a
       clc
       adc a170f
       sta a04
       
       lda a03     ;cislo sloupce??
       ldx #$ff
i1687  inx
       sec
       sbc #$18    ;odecte 24
       bcs i1687
       adc #$18    ;pricte 24
       sta a170f
       txa         ;ve kterem sprajtu? 0-3
       asl a
       asl a
       asl a
       asl a
       asl a
       asl a       ;x64 (pocet bajtu ve sprajtu)
       bcc i169d
       inc a05
i169d  clc
       adc a04
       sta a04
       bcc i16a6
       inc a05
       
i16a6  lda a170f
       lsr a
       lsr a
       lsr a
       tay
       lda a170f
       and #$07
       tax
       lda (p04),y   ;nacist puvodni hodnotu ve sprajtu
       ora f13ed,x   ;nastavit
       sta (p04),y   ;ulozit novou hodnotu
       rts


;------------ uklada do grafiky
i16bb  sta a05       ;kam to prijde
       ldy a02       ;cislo radku
      ; iny
       tya
       and #$07      ;zachovat pozici v atributu
       sta a04
       tya
       lsr a
       lsr a
       lsr a         ;x8
       tay
       beq i16dc
       
i16cc  inc a05       ;nasobeni 40 * Y
       lda a04
       clc
       adc #$40
       sta a04
       bcc i16d9
       inc a05
i16d9  dey
       bne i16cc
       
i16dc  lda a03      ;sloupec
       and #%11111000   ;$f8
       tay          ;cislo atributu
       
       lda a03      ;
       and #$07
       tax          ;poradi bitu v atributu
       lda (p04),y  ;nacist puvodni hodnotu
       ora f13ed,x  ;bitova vaha (nastavit prislusny bit)
       sta (p04),y  ;ulozit zpet
       rts

;--------------------------------------
; get name
;--------------------------------------       
i16ee  ldy #$00
       sty $c6    ;nuluje buffer klavesnice
i16f2  jsr chrin
       sta buffer,y   ;uklada text do bufferu
       cmp #$0d
       beq i1700
       iny
       jmp i16f2
       
i1700  sty name_len
       rts
       
;--------------------------------------
char2hex  cmp #$41     ;a,b,c,d,e,f
       bcc i170b
       and #$0f        ;pro pismena zachovam 1-6
       clc
       adc #$09        ;a prictu
       rts
i170b  and #%00001111  ;pro cisla
       rts

;
name_len  .byte $00

a170f     .byte $00



head_tab   .byte $6d,$68,$77,$61,$6e,$68   ;"mhwanh" hlavicka RAW souboru



;            r0  sl0 r0  sl1 r1  sl0 r1  sl1
;-------------------------------------------
f1710  .byte $04,$06,$04,$06,$04,$06,$04,$06 ;barva0   ;nezalezi na pozici
       .byte $03,$06,$04,$05,$04,$05,$03,$06 ;barva1   ;zalezi na pozici
       .byte $03,$05,$03,$05,$03,$05,$03,$05 ;barva2   ;nezalezi na pozici
       .byte $00,$05,$03,$00,$03,$00,$00,$05 ;barva3   ;zalezi na pozici
       .byte $00,$00,$00,$00,$00,$00,$00,$00 ;barva4   ;nezalezi na pozici
       .byte $01,$05,$03,$02,$03,$02,$01,$05 ;barva5   ;zalezi na pozici
       .byte $01,$00,$00,$02,$00,$02,$01,$00 ;barva6   ;zalezi
       .byte $01,$02,$01,$02,$01,$02,$01,$02 ;barva7   ;nezalezi  ;64bytes
       


;barva0 non interlaced  (uklada se do sprajtu A4-7/B4-7)
;barva1     interlaced sprites A/B
;barva2 non interlaced  (uklada se do sprajtu A0-3/B0-3)
;barva3     interlaced sprites A
;barva4 non interlaced  (hires color background)
;barva5     interlaced sprites A/B/bitmap
;barva6     interlaced sprites B
;barva7 non interlaced  (nastavuje v obou bitmapach)


       
F1750    .text "0123456789ABCDEF"
       


info_txt .text $93,$0e,"       sUPER hIRES iNTERLACE cONVERTOR",$0d,$0d,$0d
         .text "rESOLUTION: 96 * 200",$0d
         .text "cOLORS    : 4 NORMAL + 4 MIXED",$0d
         .text "mODE      : INTERLACE",$0d,$0d
         .text "in:",$0d,"raw-PIC (8 COLORS)",$0d,$0d
         .text "out:",$0d,"sUPER HIRES INTERLACE EDITOR FILE",$0d
         .text "(UNPACKED)",$0d,0

load_txt .text $0d,$0d,"lOAD NAME:",0
e1858    .text $93,$0d,$0d,"pLEASE WAIT, CREATING...",0
e1872    .text $0d,"y($00-$FF):00",$9d,$9d,0 ;offset Y
e1883    .text $0d,"x($00-$A0):00",$9d,$9d,0 ;offset X
e1894    .text $0e,$0d,"sAVE NAME:",0
file_err .text $0d,"FILE ERROR!!!",$0d,0

;E1846  .BYTE $93,$D0        ;".P
;       .BYTE $41,$4C,$4C,$45;"ALLE
;       .BYTE $54,$45,$3A,$46;"TE:F
;       .BYTE $43,$42,$30,$9D;"CB0
;       .BYTE $9D,$9D,$9D,$00;"
       

hires_col1  .byte $00
hires_col0  .byte $00

spt_color0  .byte $00
spt_color1  .byte $00
off_y       .byte $00
off_x       .byte $00

key         .byte 0

       

buffer   .byte 0 ;tady je 256 bajtu bufferu